/********************************************************************/
// First we include the libraries
#include <OneWire.h>
#include <Wire.h>
#include <DallasTemperature.h>
#include <LiquidCrystal_I2C.h>
#include <SPI.h>

//working
const int en = 2, rw = 1, rs = 0, d4 = 4, d5 = 5, d6 = 6, d7 = 7, bl = 3;

const int i2c_addr = 0x27;
const int safeFlow = 30;
const int safeTemp = 25;
int piezoPin = 8;
int i=0;
LiquidCrystal_I2C lcd(i2c_addr, en, rw, rs, d4, d5, d6, d7, bl, POSITIVE);
#define relayPin1 4
#define relayPin2 13

// Data wire is plugged into pin 2 on the Arduino
#define ONE_WIRE_BUS 12
/***************************/

volatile int flow_frequency; // Measures flow sensor pulsesunsigned 

int l_hour; // Calculated litres/hour
unsigned char flowsensor = 2; // Sensor Input
unsigned long currentTime;
unsigned long cloopTime;

void flow () // Interrupt function

{
   flow_frequency++;
}

/********************************************************************/
// Setup a oneWire instance to communicate with any OneWire devices
// (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);
/********************************************************************/
// Pass our oneWire reference to Dallas Temperature.
DallasTemperature sensors(&oneWire);
/********************************************************************/
void setup(void)
{
  digitalWrite(relayPin1, HIGH);
  lcd.begin(16, 2);
  Serial.begin(9600);
  // Start up the library
  sensors.begin();
  lcd.begin(16, 2);
  digitalWrite(relayPin1, HIGH);
  pinMode(relayPin1, OUTPUT);
  pinMode(relayPin2, OUTPUT);
   pinMode(flowsensor, INPUT);
   digitalWrite(flowsensor, HIGH); // Optional Internal Pull-Up
   Serial.begin(9600);
   attachInterrupt(0, flow, RISING); // Setup Interrupt
   sei(); // Enable interrupts
   currentTime = millis();
   cloopTime = currentTime;

  // Set the clock to run-mode, and disable the write protection
}
  


void loop(void)
{
  // call sensors.requestTemperatures() to issue a global temperature
  // request to all devices on the bus
  /********************************************************************/
  Serial.print(" Requesting temperatures...");
  sensors.requestTemperatures(); // Send the command to get temperature readings
  Serial.println("DONE");
  /********************************************************************/
  Serial.print("Temperature ST is: ");
  Serial.println(sensors.getTempCByIndex(0)); // Why "byIndex"?
  Serial.print("Temperature LT is: ");
  Serial.println(sensors.getTempCByIndex(1));
  // You can have more than one DS18B20 on the same bus.
  // 0 refers to the first IC on the wire
  /**********************************************************************/
  // Display Temperature in C
  lcd.setCursor(0, 0);
  lcd.print("Tank");
  lcd.setCursor(9, 0);
  // Display Temperature in C
  lcd.print(sensors.getTempCByIndex(0));
  lcd.setCursor(14, 0);
  lcd.print("C");
  lcd.setCursor(0, 1);
  lcd.print("LasrTube");
  lcd.setCursor(9, 1);
  // Display Temperature in C
  lcd.print(sensors.getTempCByIndex(1));
  lcd.setCursor(14, 1);
  lcd.print("C");
  /*********************************************************************/
  if ((sensors.getTempCByIndex(0)) >  safeTemp) {
    (digitalWrite(relayPin1, LOW));
  } else {
    (digitalWrite(relayPin1, HIGH));
  } 
  if ((l_hour < safeFlow)) {
    (digitalWrite(relayPin2, LOW));
  } else {
    (digitalWrite(relayPin2, HIGH));
  }
  /*********************************************************************/

 if ((sensors.getTempCByIndex(0)) >  safeTemp) {
      for(i=600;i<900;i++){
  tone(9,i);
  delay(10);
  }
  for(i=900;i>600;i--){
  tone(9,i);
  delay(10);
  }
  }
 else {(noTone(9));}
   {
   currentTime = millis();
   // Every second, calculate and print litres/hour
   if(currentTime >= (cloopTime + 1000))
   {
      cloopTime = currentTime; // Updates cloopTime
      // Pulse frequency (Hz) = 7.5Q, Q is flow rate in L/min.
      l_hour = (flow_frequency * 60 / 7.5); // (Pulse frequency x 60 min) / 7.5Q = flowrate in L/hour
      flow_frequency = 0; // Reset Counter
      Serial.print(l_hour, DEC); // Print litres/hour
      Serial.println(" L/hour");
   }
   if (l_hour < 30)  {
      for(i=600;i<900;i++){
  tone(9,i);
  delay(10);
  }
  for(i=900;i>600;i--){
  tone(9,i);
  delay(10);
  }} else {(noTone(9));}
  }
    /*********************************************************************/
 
  /*********************************************************************/
  }
